//Reads HCI
//Mon Nov 19 22:20:24 PST 2001
//Ben Lynn
/*
Copyright (C) 2002 Benjamin Lynn (blynn@cs.stanford.edu)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "hci.h"

static char *program_name = "hcitry";

int main(int argc, char **argv)
{
    SMMRegisters reg;
    long int b, c;
    long int oldc, oldd;

    if (argc < 3) {
	printf("Usage: %s BX CX\n", program_name);
	return 0;
    }

    b = strtol(argv[1], NULL, 16);
    c = strtol(argv[2], NULL, 16);

    printf("hci try on %04X, %04X\n", (unsigned) b, (unsigned) c);

    reg.eax = HCI_GET;
    reg.ebx = b;

    HciFunction(&reg);
    printf("Before: ");
    printf("%04X %04X %04X %04X\n", reg.eax, reg.ebx, reg.ecx, reg.edx);
    oldc = reg.ecx;
    oldd = reg.edx;

    reg.eax = HCI_SET;
    reg.ebx = b;
    reg.ecx = c;

    HciFunction(&reg);
    printf("After:  ");
    printf("%04X %04X %04X %04X\n", reg.eax, reg.ebx, reg.ecx, reg.edx);

    printf("Delaying 2 seconds...");
    sleep(2);

    reg.eax = HCI_SET;
    reg.ebx = b;
    reg.ecx = oldc;
    reg.edx = oldd;

    HciFunction(&reg);
    printf("Final:  ");
    printf("%04X %04X %04X %04X\n", reg.eax, reg.ebx, reg.ecx, reg.edx);

    return 0;
}
