//Probes HCI, SCI
//Mon Nov 19 22:07:15 PST 2001
//Ben Lynn
/*
Copyright (C) 2002 Benjamin Lynn (blynn@cs.stanford.edu)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>

#include "hci.h"
#include "sci.h"

int main(int argc, char **argv)
{
    SMMRegisters reg;
    int i;

    printf("probing hci...\n");
    for (i=0; i<=0x100; i++) {
	reg.eax = HCI_GET;
	reg.ebx = i;

	HciFunction(&reg);
	if (!(reg.eax & 0x8000)) {
	    printf("%04X: ", i);
	    printf("%04X %04X %04X %04X\n", reg.eax, reg.ebx, reg.ecx, reg.edx);
	}
    }

    printf("probing sci...\n");
    SciOpenInterface();
    //reg.ebx = 0x11d;
    //reg.ecx = 5;
    for (i=0; i<=0xFFFF; i++) {
	reg.ebx = i;

	SciGet(&reg);
	//printf("%04X %04X %04X %04X\n", reg.eax, reg.ebx, reg.ecx, reg.edx);
	if (!(reg.eax & 0x8000)) {
	    printf("%04X: ", i);
	    printf("%04X %04X %04X %04X\n", reg.eax, reg.ebx, reg.ecx, reg.edx);
	}
    }
    SciCloseInterface();
    return 0;
}
