//Changes boot order
//Mon Feb 18 13:04:23 PST 2002
//Ben Lynn
/*
Copyright (C) 2002 Benjamin Lynn (blynn@cs.stanford.edu)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "sci.h"

static char *program_name = "tbootorder";

static char *order[] = {
    "FHCL",
    "HFCL",
    "FCLH",
    "HCLF",
    "CLFH",
    "CLHF"
};

int main(int argc, char **argv)
{
    SMMRegisters reg;
    long int c;
    int version;
    int i;

    if (SciSupportCheck(&version)==SCI_FAILURE) {
	fprintf(stderr, "%s: this computer is not supported "
	    "or the kernel module is not installed.\n", program_name);
	return 1;
    }

    SciOpenInterface();

    reg.ebx = 0x11d;

    SciGet(&reg);

    SciCloseInterface();

    c = reg.ecx & 255;

    if (argc < 2) {
	printf("Usage: %s BOOTORDER\n", program_name);
	for (i=0; i<=5; i++) {
	    printf("  %d = %s\n", i, order[i]);
	}
	printf("(F = FDD, H = HDD, C = CD, L = LAN)\n");
	printf("Current bootorder: %d\n", (int) c);
	return 0;
    } else {
	c = strtol(argv[1], NULL, 16);
	if (c < 0) c = 0;
	else if (c > 5) c = 5;
    }

    SciOpenInterface();

    reg.ebx = 0x11d;
    reg.ecx = c;

    SciSet(&reg);

    SciCloseInterface();

    return 0;
}
