//Changes CPU speed
//Mon Feb 18 13:04:23 PST 2002
//Ben Lynn
/*
Copyright (C) 2002 Benjamin Lynn (blynn@cs.stanford.edu)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include "hci.h"
#include "sci.h"

static char *program_name = "tcpuspeed";

int main(int argc, char **argv)
{
    SMMRegisters reg;
    long int b, c;
    int version;

    if (SciSupportCheck(&version)==SCI_FAILURE) {
	fprintf(stderr, "%s: this computer is not supported "
	    "or the kernel module is not installed.\n", program_name);
	return 1;
    }

    b = 0x32;
    reg.eax = HCI_GET;
    reg.ebx = b;
    HciFunction(&reg);
    c = (reg.ecx >> 13) & 7;

    if (argc < 2) {
	printf("Usage: %s [CPUSPEED|+|-]\n", program_name);
	printf("  0 <= CPUSPEED <= 7\n");
	printf("  0 - fastest, 7 - slowest\n");
	printf("Current speed: %d\n", (int) c);
	return 0;
    } else if (argv[1][0] == '+') {
	c--;
    } else if (argv[1][0] == '-') {
	c++;
    } else {
	c = strtol(argv[1], NULL, 16);
    }
    if (c < 0) c = 0;
	else if (c > 7) c = 7;
	c = c << 13;
    


    reg.eax = HCI_SET;
    reg.ebx = b;
    reg.ecx = c;

    HciFunction(&reg);

    return 0;
}
